// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package svidstorev1

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// SVIDStoreClient is the client API for SVIDStore service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type SVIDStoreClient interface {
	// Puts an X509-SVID in a configured secrets store
	PutX509SVID(ctx context.Context, in *PutX509SVIDRequest, opts ...grpc.CallOption) (*PutX509SVIDResponse, error)
	// Deletes an SVID from the store
	DeleteX509SVID(ctx context.Context, in *DeleteX509SVIDRequest, opts ...grpc.CallOption) (*DeleteX509SVIDResponse, error)
}

type sVIDStoreClient struct {
	cc grpc.ClientConnInterface
}

func NewSVIDStoreClient(cc grpc.ClientConnInterface) SVIDStoreClient {
	return &sVIDStoreClient{cc}
}

func (c *sVIDStoreClient) PutX509SVID(ctx context.Context, in *PutX509SVIDRequest, opts ...grpc.CallOption) (*PutX509SVIDResponse, error) {
	out := new(PutX509SVIDResponse)
	err := c.cc.Invoke(ctx, "/spire.plugin.agent.svidstore.v1.SVIDStore/PutX509SVID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *sVIDStoreClient) DeleteX509SVID(ctx context.Context, in *DeleteX509SVIDRequest, opts ...grpc.CallOption) (*DeleteX509SVIDResponse, error) {
	out := new(DeleteX509SVIDResponse)
	err := c.cc.Invoke(ctx, "/spire.plugin.agent.svidstore.v1.SVIDStore/DeleteX509SVID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// SVIDStoreServer is the server API for SVIDStore service.
// All implementations must embed UnimplementedSVIDStoreServer
// for forward compatibility
type SVIDStoreServer interface {
	// Puts an X509-SVID in a configured secrets store
	PutX509SVID(context.Context, *PutX509SVIDRequest) (*PutX509SVIDResponse, error)
	// Deletes an SVID from the store
	DeleteX509SVID(context.Context, *DeleteX509SVIDRequest) (*DeleteX509SVIDResponse, error)
	mustEmbedUnimplementedSVIDStoreServer()
}

// UnimplementedSVIDStoreServer must be embedded to have forward compatible implementations.
type UnimplementedSVIDStoreServer struct {
}

func (UnimplementedSVIDStoreServer) PutX509SVID(context.Context, *PutX509SVIDRequest) (*PutX509SVIDResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method PutX509SVID not implemented")
}
func (UnimplementedSVIDStoreServer) DeleteX509SVID(context.Context, *DeleteX509SVIDRequest) (*DeleteX509SVIDResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteX509SVID not implemented")
}
func (UnimplementedSVIDStoreServer) mustEmbedUnimplementedSVIDStoreServer() {}

// UnsafeSVIDStoreServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to SVIDStoreServer will
// result in compilation errors.
type UnsafeSVIDStoreServer interface {
	mustEmbedUnimplementedSVIDStoreServer()
}

func RegisterSVIDStoreServer(s grpc.ServiceRegistrar, srv SVIDStoreServer) {
	s.RegisterService(&SVIDStore_ServiceDesc, srv)
}

func _SVIDStore_PutX509SVID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(PutX509SVIDRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SVIDStoreServer).PutX509SVID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/spire.plugin.agent.svidstore.v1.SVIDStore/PutX509SVID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SVIDStoreServer).PutX509SVID(ctx, req.(*PutX509SVIDRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _SVIDStore_DeleteX509SVID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteX509SVIDRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SVIDStoreServer).DeleteX509SVID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/spire.plugin.agent.svidstore.v1.SVIDStore/DeleteX509SVID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SVIDStoreServer).DeleteX509SVID(ctx, req.(*DeleteX509SVIDRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// SVIDStore_ServiceDesc is the grpc.ServiceDesc for SVIDStore service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var SVIDStore_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "spire.plugin.agent.svidstore.v1.SVIDStore",
	HandlerType: (*SVIDStoreServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "PutX509SVID",
			Handler:    _SVIDStore_PutX509SVID_Handler,
		},
		{
			MethodName: "DeleteX509SVID",
			Handler:    _SVIDStore_DeleteX509SVID_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "spire/plugin/agent/svidstore/v1/svidstore.proto",
}
